package im;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

public class JSONFactory
{
	// Protect the constructor, so no other class can call it
	private JSONFactory()
	{
	}

	// Create the only instance, save it to a private static variable
	private static JSONFactory instance = new JSONFactory();

	// Make the static instance publicly available
	public static JSONFactory getInstance() { return instance; }

	public JSONArray buildDebugMsg(String type, String msg)
	{
		JSONArray arr = new JSONArray();
		
		JSONObject tmp = new JSONObject();
		tmp.put(type, msg);
		arr.add(tmp);

		return arr;
	}
}