package im;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.simple.JSONArray;

/**
 * Servlet implementation class Message
 */
@WebServlet("/message")
public class Message extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Message() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		String send = request.getParameter("send");
		String receive = request.getParameter("receive");
		String to = request.getParameter("to");
		String msg = request.getParameter("msg");
		PrintWriter pw = response.getWriter();
		
		Clients cls = Clients.getInstance();
		HashMap<String, String> clients = cls.getClients();
		JSONFactory jf = JSONFactory.getInstance();
		JSONArray res;
		Messages msgs = Messages.getInstance();
		
		if (send != null)
		{
			if (to.length() <= 0)
			{
				res = jf.buildDebugMsg("error", "Parameter 'to' missing");
				pw.println(res);
				return;
			}
			
			if (msg.length() <= 0)
			{
				res = jf.buildDebugMsg("error", "Parameter 'msg' missing");
				pw.println(res);
				return;
			}
			
			String userIP = clients.get(to);
			
			if (userIP == null)
			{
				res = jf.buildDebugMsg("error", "Requested username is not valid.");
				pw.println(res);
				return;
			}
			
			if (userIP == "none")
			{
				res = jf.buildDebugMsg("info", "Requested user is offline.");
				pw.println(res);
				return;
			}
			
			String sender = cls.getUsername(request.getRemoteAddr());
			
			msgs.addMsg(sender, msg, to);

			pw.println(jf.buildDebugMsg("info", "Message sent."));
			return;
		}
		
		if (receive != null)
		{
			String username = cls.getUsername(request.getRemoteAddr());
			
			pw.println(msgs.getMessagesJSON(username));
			return;
		}
		
		pw.println(jf.buildDebugMsg("error", "Incorrect, misspelled or missing parameters."));
	}
}
