package im;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

public class Messages
{
	// Protect the constructor, so no other class can call it
	private Messages()
	{
	}

	// Create the only instance, save it to a private static variable
	private static Messages instance = new Messages();

	// Make the static instance publicly available
	public static Messages getInstance() { return instance; }

	private HashMap<String, Vector<String[]>> messages = new HashMap<String, Vector<String[]>>();
	
	public void addMsg(String sender, String message, String recepient)
	{
		String[] value = new String[2];
		value[0] = sender;
		value[1] = message;
		
		if (!this.messages.containsKey(recepient))
		{
			this.messages.put(recepient, new Vector<String[]>());
		}
		
		this.messages.get(recepient).add(value);
	}
	
	public void printAllMessages()
	{
		for (String key : this.messages.keySet())
		{
			System.out.println(key + ":");
			
			Vector<String[]> msgs = this.messages.get(key);
			Iterator<String[]> itr = msgs.iterator();
			
			while (itr.hasNext())
			{
				String[] tmp = itr.next();
				System.out.println("\t" + tmp[0] + " : " + tmp[1]);
			}
		}
	}
	
	public JSONArray getMessagesJSON(String recepient)
	{
		if (this.messages.containsKey(recepient))
		{
			JSONArray messages = new JSONArray();
			
			Vector<String[]> msgs = this.messages.get(recepient);
			Iterator<String[]> itr = msgs.iterator();
			
			while (itr.hasNext())
			{
				JSONObject tmp = new JSONObject();
				String[] value = itr.next();
				
				tmp.put("from", value[0]);
				tmp.put("msg", value[1]);
				
				messages.add(tmp);
			}
			
			this.messages.remove(recepient);
			
			return messages;
		}
		else
		{
			JSONFactory jf = JSONFactory.getInstance();
			return jf.buildDebugMsg("info", "No new messages.");
		}
	}
	
}