package im;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.simple.JSONArray;

/**
 * Servlet implementation class Sign
 */
@WebServlet(
		urlPatterns = { "/sign" }
		)
public class Sign extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Sign() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		Clients cls = Clients.getInstance();
		JSONFactory jf = JSONFactory.getInstance();
		JSONArray res;
		PrintWriter pw = response.getWriter();
		
		String in = request.getParameter("in");
		String out = request.getParameter("out");
		String ip = request.getRemoteAddr();
		int result = -2;
		String method = "";
		
		if (in != null && in.length() != 0)
		{
			method = "in";
			result = cls.signInClient(in, ip);
		}
		
		if (out != null && out.length() != 0)
		{
			method = "out";
			result = cls.signOutClient(out);
		}
		
		switch (result)
		{
			case 0:
				pw.println(cls.clientsToJSON().toString());
				break;
			case 1:
				res = jf.buildDebugMsg("error", "User is already signed " + method + ".");
				pw.println(res);
				break;
			case -1:
				res = jf.buildDebugMsg("error", "Username not found in IdM.");
				pw.println(res);
				break;
			default:
				res = jf.buildDebugMsg("error", "Unexpected error occured.");
				pw.println(res);
		}
	}
}
